"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HexString = void 0;
const buffer_1 = require("buffer/"); // the trailing slash is important!
class HexString {
    /// We want to make sure this hexString has the `0x` hex prefix
    hexString;
    static fromBuffer(buffer) {
        return new HexString(buffer.toString("hex"));
    }
    static fromUint8Array(arr) {
        return HexString.fromBuffer(buffer_1.Buffer.from(arr));
    }
    static ensure(hexString) {
        if (typeof hexString === "string") {
            return new HexString(hexString);
        }
        return hexString;
    }
    constructor(hexString) {
        if (hexString.startsWith("0x")) {
            this.hexString = hexString;
        }
        else {
            this.hexString = `0x${hexString}`;
        }
    }
    hex() {
        return this.hexString;
    }
    noPrefix() {
        return this.hexString.slice(2);
    }
    toString() {
        return this.hex();
    }
    toBuffer() {
        return buffer_1.Buffer.from(this.noPrefix(), "hex");
    }
    toUint8Array() {
        return Uint8Array.from(this.toBuffer());
    }
}
exports.HexString = HexString;
//# sourceMappingURL=hex_string.js.map